moSetGetInputOutputLs = {};

function moSetGetInputOutputLs:getPlaceableGreenhouse(self, objectTable)	
	local inputFillTypes={};
	local outputFillTypes={};	
	local container = 1;
	local ratio = 0;
	local productivity = 0;
	local productivityColor = moGuiMiniPdaSlots.warningColor0;
	local fillLevel = 0;
	local capacity = 0;
	local inputEmpty = false;
	if objectTable ~= nil and objectTable.configFileName ~= nil then		
		local foundWaterFillLevel = false;
		if objectTable.waterTankCapacity ~= nil and objectTable.waterTankFillLevel ~= nil then				
			local info={};
			local fillType = FillUtil.fillTypeNameToInt["water"];					
			info.capacity = objectTable.waterTankCapacity;
			info.fillLevel = objectTable.waterTankFillLevel;
			--if info.fillLevel > 0.1 then foundWaterFillLevel = true;end;
			if info.fillLevel <= 0.1 then inputEmty = true;end;
			if not inputEmty then
				fillLevel = fillLevel+info.fillLevel;
				capacity = capacity+info.capacity;
			end;
			--ratio = Utils.getNoNil(info.fillLevel/info.capacity*100, 0);
			--if tonumber(productivity) >= tonumber(ratio) then
			--	productivity = tonumber(ratio);	
			--end;
			info.container = container;					
			info.fillTypeName = "";
			info.lengthFillTypes = 1;					
			inputFillTypes[container] = {};
			local pricePerLiter, fillTypeNameString = moSetGetInputOutputLs:getFillTypeStringName(self, fillType, info.fillTypeName, nil);					
			info.fillTypeName = fillTypeNameString;
			info.pricePerLiter = pricePerLiter;
			table.insert(inputFillTypes[container], info);
			container = container+1;
			table.remove(info);
		end;
		local foundManureFillLevel = false;
		if objectTable.manureCapacity ~= nil and objectTable.manureFillLevel ~= nil then
			local info={};
			local fillType = FillUtil.fillTypeNameToInt["manure"];
			info.capacity = objectTable.manureCapacity;
			info.fillLevel = objectTable.manureFillLevel;
			--if info.fillLevel > 0.1 then foundManureFillLevel = true;end;
			if info.fillLevel <= 0.1 then inputEmty = true;end;
			if not inputEmty then
				fillLevel = fillLevel+info.fillLevel;
				capacity = capacity+info.capacity;
			end;
			--ratio = Utils.getNoNil(info.fillLevel/info.capacity*100, 0);
			--if tonumber(productivity) >= tonumber(ratio) then
			--	productivity = tonumber(ratio);	
			--end;
			info.container = container;					
			info.fillTypeName = "";
			info.lengthFillTypes = 1;					
			inputFillTypes[container] = {};
			local pricePerLiter, fillTypeNameString = moSetGetInputOutputLs:getFillTypeStringName(self, fillType, info.fillTypeName, nil);					
			info.fillTypeName = fillTypeNameString;
			info.pricePerLiter = pricePerLiter;
			table.insert(inputFillTypes[container], info);
			container = container+1;
			table.remove(info);
		end;
		container = 1;
		function setIncomePerHour()
			local info = {};			
			info.fillTypeName = tostring(moLanguageXml:getTxt("greenhousels"));		
			info.lengthFillTypes = 1;		
			info.pricePerLiter = 0;
			if not inputEmpty then info.pricePerLiter = Utils.getNoNil(objectTable.incomePerHour, 0);end;		
			info.fillLevel = 0;
			info.capacity = -2;		
			outputFillTypes[container] = {};
			table.insert(outputFillTypes[container], info);
			table.remove(info);
		end;
		setIncomePerHour();	
		productivity = Utils.getNoNil(fillLevel/capacity*100, 0);
		if not inputEmty then
			if tonumber(productivity) <= 90 and tonumber(productivity) >= 75 then
				productivityColor = moGuiMiniPdaSlots.warningColor1;
			elseif tonumber(productivity) < 75 and tonumber(productivity) >= 50 then
				productivityColor = moGuiMiniPdaSlots.warningColor2;
			elseif tonumber(productivity) < 50 and tonumber(productivity) >= 25 then
				productivityColor = moGuiMiniPdaSlots.warningColor3;
			elseif tonumber(productivity) < 25 then
				productivityColor = moGuiMiniPdaSlots.warningColor4;
			end;
		else
			productivity = 0;
			productivityColor = moGuiMiniPdaSlots.warningColor4;			
		end;		
		outputFillTypes[1][1].productivity = productivity;
		outputFillTypes[1][1].productivityColor = productivityColor;
	end;		
	return inputFillTypes, outputFillTypes
end;

function moSetGetInputOutputLs:getAnimals(self, objectTable, xmlModString)
	local inputFillTypes={};
	local outputFillTypes={};	
	local container = 1;	
	function setAllValues()		
		local info = {};
		info.fillTypeName = tostring(moLanguageXml:getTxt(xmlModString)).. " ".. tostring(moLanguageXml:getTxt("amount", nil, "Amount"));		
		info.lengthFillTypes = 1;
		info.pricePerLiter = getAnimalStorePrice(self, objectTable.name);		
		info.fillLevel = Utils.getNoNil(objectTable.totalNumAnimals, 0);
		info.capacity = -1;
		info.productivity = string.format("%1.0f", Utils.getNoNil(objectTable.productivity*100, 0)); --Utils.getNoNil(objectTable.productivity*100, 0); --string.format("%0.0f", Utils.getNoNil(0, 0));
		info.productivityColor = getProductivityColor(self, info.productivity); --moGuiExtras.colors['green'];
		outputFillTypes[container] = {};
		table.insert(outputFillTypes[container], info);
		container = container+1;
		--cleanlinessFactor
		info = {};
		info.fillLevel = 0;
		info.capacity = -2;
		info.pricePerLiter = 0;
		info.fillTypeName = tostring(moLanguageXml:getTxt("a_cleanliness", nil, "Cleanliness"));
		info.extraText = string.format("%1.0f", Utils.getNoNil(objectTable.cleanlinessFactor*100, 0));
		info.setColor = getProductivityColor(self, info.extraText);
		info.extraText = info.extraText.. "%";
		info.lengthFillTypes = 1;
		outputFillTypes[container] = {};
		table.insert(outputFillTypes[container], info);
		container = container+1;
		table.remove(info);
	end;
	if objectTable.name == "chicken" and objectTable.totalNumAnimals >= 2 then	
		setAllValues();		
		local info = {};
		--ls17
		--info.fillLevel = Utils.getNoNil(g_currentMission:getSiloAmount(FillUtil.FILLTYPE_EGG), 0);
		info.fillLevel = Utils.getNoNil(g_currentMission:getNumPickupObjects(FillUtil.FILLTYPE_EGG), 0);
		info.capacity = -1;
		info.pricePerLiter = getEggPrice(self, FillUtil.FILLTYPE_EGG);
		info.fillTypeName = tostring(moLanguageXml:getTxt("a_pickup", nil, "Pickup"));		
		info.lengthFillTypes = 1;
		outputFillTypes[container] = {};
		table.insert(outputFillTypes[container], info);
		container = container+1;
		info = {};
		info.fillLevel = Utils.getNoNil(objectTable.numActivePickupObjects, 0);
		info.capacity = -1;
		info.fillTypeName = tostring(moLanguageXml:getTxt("a_egg1", nil, "Eggs in the barn"));		
		info.lengthFillTypes = 1;
		info.setColor = moGuiMiniPdaSlots.warningColor0;
		local egg = tonumber(info.fillLevel);
		if egg >= 54 then info.setColor = moGuiMiniPdaSlots.warningColor3;end;
		if egg < 54 and egg >= 40 then info.setColor = moGuiMiniPdaSlots.warningColor2;end;
		if egg < 40 and egg >= 20 then info.setColor = moGuiMiniPdaSlots.warningColor1;end;
		info.pricePerLiter = 0;
		outputFillTypes[container] = {};
		table.insert(outputFillTypes[container], info);		
		container = 1;		
		if moGeneralSettings.watermod and moMapObjects.watermod[objectTable.name] ~= nil then
			for a=1, moMapObjects.watermod[objectTable.name].length do				
				local info = {};				
				info.capacity = 0;
				if moGuiMiniPdaSlots.animalsCapacity then
					info.capacity = Utils.getNoNil(objectTable.totalNumAnimals * (tonumber(moMapObjects.watermod[objectTable.name][a][2]) or 0) * 6,0);
				end;
				info.fillLevel = 0;
				info.pricePerLiter = 0;
				local fillTypeIndex = tonumber(moMapObjects.watermod[objectTable.name][a][1]);
				info.fillLevel = Utils.getNoNil(objectTable:getFillLevel(fillTypeIndex), 0);				
				local waterModFruitName = getWaterModFruitName(self, fillTypeIndex);
				local fillName = tostring(moLanguageXml:getTxt("a_foragemix", nil, "FeedTrog"))
				if string.find(waterModFruitName, "water") then fillName = tostring(moLanguageXml:getTxt("a_watertrough", nil, "WaterTrog"));end;
				if string.find(waterModFruitName, "wheat") then fillName = tostring(moLanguageXml:getTxt("a_wheattrough", nil, "WheatTrog"));end;
				info.fillTypeName = fillName;				
				info.lengthFillTypes = 1;
				inputFillTypes[container] = {};
				table.insert(inputFillTypes[container], info);
				container=container+1;
				table.remove(info);
			end;
		end;
		table.remove(info);
	end;	
	if objectTable.name == "sheep" and objectTable.totalNumAnimals >= 1 then	
		setAllValues();
		local info = {};
		info.fillLevel = 0;
		info.capacity = -1;
		info.pricePerLiter = getFruitPrice(self, FillUtil.FILLTYPE_WOOL);
		info.fillTypeName = tostring(moLanguageXml:getTxt("a_wool", nil, "Wool"));
		info.setColor = moGuiMiniPdaSlots.siloColor;
		info.lengthFillTypes = 1;
		if objectTable.currentPallet ~= nil then --currentPalletFillPercentage
			info.fillLevel = Utils.getNoNil(objectTable.currentPallet.fillLevel, 0);
			info.capacity = Utils.getNoNil(objectTable.currentPallet.capacity, 0);
			local checkCapacity = tonumber(info.fillLevel)/tonumber(info.capacity)*100;
			if checkCapacity >= 85 then info.setColor = moGuiMiniPdaSlots.warningColor3;end;
			if checkCapacity <= 85 and checkCapacity >= 50 then info.setColor = moGuiMiniPdaSlots.warningColor2;end;
			if checkCapacity <= 50 and checkCapacity >= 25 then info.setColor = moGuiMiniPdaSlots.warningColor0;end;
		elseif objectTable.currentPalletFillPercentage ~= nil and objectTable.currentPalletFillPercentage > 0 then
			info.fillLevel = objectTable.currentPalletFillPercentage*20;
			info.capacity = 2000;
			local checkCapacity = tonumber(info.fillLevel)/tonumber(info.capacity)*100;
			if checkCapacity >= 85 then info.setColor = moGuiMiniPdaSlots.warningColor3;end;
			if checkCapacity <= 85 and checkCapacity >= 50 then info.setColor = moGuiMiniPdaSlots.warningColor2;end;
			if checkCapacity <= 50 and checkCapacity >= 25 then info.setColor = moGuiMiniPdaSlots.warningColor0;end;
		end;		
		outputFillTypes[container] = {};
		table.insert(outputFillTypes[container], info);
		container = container+1;		
		if objectTable.palSammler ~= nil then
			for k, objectPal in pairs(objectTable.palSammler) do				
				local info = {};
				info.capacity = 0;
				info.fillLevel = 0;
				info.container = container;					
				info.fillTypeName = moLanguageXml:getTxt("palsammler", nil, "PalCollector");
				info.lengthFillTypes = 1;
				info.pricePerLiter = 0;
				info.setColor = moGuiMiniPdaSlots.warningColor0
				local objCreate = objectTable.palSammler[k];
				local fremdObj = nil;
				local full = false;
				if not MultiOverlayV2.isMp or MultiOverlayV2.loadHostServer then
					fremdObj = objCreate.fremdObject;
				elseif objCreate.Lamp ~= nil and objCreate.Lamp[1].s ~= nil then
					if objCreate.Lamp[1].s == 1 then fremdObj = 1;end;
					if objCreate.Lamp[1].s == 3 then full = true;end;
				end;				
				info.capacity = Utils.getNoNil(table.getn(objCreate.Points), 1);
				local noticePal = 0;				
				if info.capacity > 1 then
					if not full then
						for i = 1, info.capacity do
							if not MultiOverlayV2.isMp or MultiOverlayV2.loadHostServer then							
								if objCreate.Points[i].Pallet ~= nil then
									noticePal = noticePal+1;							
								end;
							elseif objCreate.Points[i].node2 ~= nil and moFillUtilPallet ~= nil then							
								local x, y, z = getWorldTranslation(objCreate.Points[i].node2);
								x = tonumber(math.floor(x + .5));
								y = tonumber(math.floor(y + .5));
								z = tonumber(math.floor(z + .5));							
								for nodeId, mapFillUtilPal in pairs(moFillUtilPallet) do							
									if moFillUtilPallet[nodeId].x == x and moFillUtilPallet[nodeId].z == z and moFillUtilPallet[nodeId].fillLevel >= 0.1 then
										noticePal = noticePal+1;
										break;
									end;
								end;
							end;
						end;
					else
						noticePal = info.capacity;
					end;
				end;							
				info.fillLevel = info.fillLevel+noticePal;
				if fremdObj ~= nil and fremdObj > 0 then 
					info.fillTypeName = moLanguageXml:getTxt("palsammlerblocked", nil, "Blocked !!");
					info.setColor = moGuiMiniPdaSlots.warningColor2;
				else
					if info.fillLevel >= info.capacity then info.setColor = moGuiMiniPdaSlots.warningColor4;end;
					if info.fillLevel >= info.capacity/2 and info.fillLevel < info.capacity then info.setColor = moGuiMiniPdaSlots.warningColor2;end;
				end;				
				outputFillTypes[container] = {};
				table.insert(outputFillTypes[container], info);
				container = container+1;
				table.remove(info);
			end;
		end;
		container = 1;		
		info = {};
		info.fillLevel = Utils.getNoNil(objectTable:getFillLevel(FillUtil.FILLTYPE_WATER), 0)
		info.capacity = 0;
		--if moGuiMiniPdaSlots.animalsCapacity then
		--	info.capacity = Utils.getNoNil(objectTable.totalNumAnimals *  g_forageUsagePerAnimalPerDay.sheep * 6,0);
		--end;
		info.pricePerLiter = 0;
		info.fillTypeName = tostring(moLanguageXml:getTxt("a_watertrough", nil, "WaterTrog"));		
		info.lengthFillTypes = 1;
		inputFillTypes[container] = {};
		table.insert(inputFillTypes[container], info);
		container = container+1;
		info = {};
		info.fillLevel = Utils.getNoNil(objectTable:getFillLevel(FillUtil.FILLTYPE_GRASS_WINDROW), 0)+Utils.getNoNil(objectTable:getFillLevel(FillUtil.FILLTYPE_DRYGRASS_WINDROW), 0);
		info.capacity = 0;
		--if moGuiMiniPdaSlots.animalsCapacity then
		--	info.capacity = Utils.getNoNil(objectTable.totalNumAnimals *  g_forageUsagePerAnimalPerDay.sheep * 6,0);
		--end;
		info.pricePerLiter = 0;
		info.fillTypeContainerName = tostring(moLanguageXml:getTxt("a_foodtrough", nil, "Foodtrough")).. "(G)";
		info.fillTypeName = moSetGetInputOutputLs:getFillTypeName(FillUtil.FILLTYPE_GRASS_WINDROW).. ",".. moSetGetInputOutputLs:getFillTypeName(FillUtil.FILLTYPE_DRYGRASS_WINDROW);		
		info.lengthFillTypes = 2;
		inputFillTypes[container] = {};
		table.insert(inputFillTypes[container], info);
		table.remove(info);
	end;
	if objectTable.name == "cow" and objectTable.totalNumAnimals >= 1 then
		setAllValues();		
		local info = {};
		info.fillLevel = Utils.getNoNil(objectTable.fillLevelMilk, 0);
		info.capacity = 0;		
		info.pricePerLiter = getFruitPrice(self, FillUtil.FILLTYPE_MILK);
		info.fillTypeName = tostring(moLanguageXml:getTxt("a_milk", nil, "Milk"));		
		info.lengthFillTypes = 1;
		outputFillTypes[container] = {};
		table.insert(outputFillTypes[container], info);
		container = container+1;
		if g_currentMission.triggerExtendSellMilk ~= nil or g_currentMission.orgFSsellMilk ~= nil and g_currentMission.orgFSsellMilk or not objectTable.automaticallySellMilk then
			info = {};
			info.fillLevel = 0;
			info.capacity = -2;
			info.pricePerLiter = 0;
			info.fillTypeName = tostring(moLanguageXml:getTxt("a_milkbuy", nil, "AutoMilkBuy"));
			info.extraText = tostring(moLanguageXml:getTxt("off", nil, "Off"));
			info.setColor = moGuiMiniPdaSlots.warningColor3;		
			info.lengthFillTypes = 1;
			outputFillTypes[container] = {};
			table.insert(outputFillTypes[container], info);
			container = container+1;
		end;
		if objectTable.manureFillLevel ~= nil then
			info = {};
			info.fillLevel = Utils.getNoNil(objectTable.manureFillLevel, 0);
			info.capacity = 0;
			info.pricePerLiter = getFruitPrice(self, FillUtil.FILLTYPE_MANURE);
			info.fillTypeName = tostring(moLanguageXml:getTxt("a_manure", nil, "Manure"));		
			info.lengthFillTypes = 1;
			outputFillTypes[container] = {};
			table.insert(outputFillTypes[container], info);
			container = container+1;
		end;
		if objectTable.liquidManureTrigger ~= nil and objectTable.liquidManureTrigger.fillLevel ~= nil then
			info = {};
			info.fillLevel = Utils.getNoNil(objectTable.liquidManureTrigger.fillLevel, 0);
			info.capacity = 0;
			--if moGuiMiniPdaSlots.animalsCapacity then
			--	info.capacity = Utils.getNoNil(objectTable.liquidManureTrigger.capacity, 0);
			--end;
			info.pricePerLiter = getFruitPrice(self, FillUtil.FILLTYPE_LIQUIDMANURE);
			info.fillTypeName = tostring(moLanguageXml:getTxt("a_liquidmanure", nil, "LiquidManure"));		
			info.lengthFillTypes = 1;
			outputFillTypes[container] = {};
			table.insert(outputFillTypes[container], info);
		end;
		container = 1;
		info = {};
		info.fillLevel = Utils.getNoNil(objectTable:getFillLevel(FillUtil.FILLTYPE_WATER), 0)
		info.capacity = 0;
		--if moGuiMiniPdaSlots.animalsCapacity then
		--	info.capacity = Utils.getNoNil(objectTable.totalNumAnimals *  g_forageUsagePerAnimalPerDay.sheep * 6,0);
		--end;
		info.pricePerLiter = 0;
		info.fillTypeName = tostring(moLanguageXml:getTxt("a_watertrough", nil, "WaterTrog"));		
		info.lengthFillTypes = 1;
		inputFillTypes[container] = {};
		table.insert(inputFillTypes[container], info);
		container = container+1;
		info = {};
		info.fillLevel = Utils.getNoNil(objectTable:getFillLevel(FillUtil.FILLTYPE_STRAW), 0);
		info.capacity = 0;
		--if moGuiMiniPdaSlots.animalsCapacity then
		--	info.capacity = Utils.getNoNil(objectTable.totalNumAnimals *  g_forageUsagePerAnimalPerDay.sheep * 6,0);
		--end;
		info.pricePerLiter = 0;		
		info.fillTypeName = tostring(moLanguageXml:getTxt("a_straw", nil, "Straw"));	
		info.lengthFillTypes = 1;
		inputFillTypes[container] = {};
		table.insert(inputFillTypes[container], info);
		container = container+1;
		info = {};
		info.fillLevel = Utils.getNoNil(objectTable:getFillLevel(FillUtil.FILLTYPE_GRASS_WINDROW), 0);
		info.capacity = 0;
		--if moGuiMiniPdaSlots.animalsCapacity then
		--	info.capacity = Utils.getNoNil(objectTable.totalNumAnimals *  g_forageUsagePerAnimalPerDay.sheep * 6,0);
		--end;
		info.pricePerLiter = 0;		
		info.fillTypeName = tostring(moLanguageXml:getTxt("a_grass", nil, "Grass"));		
		info.lengthFillTypes = 1;
		inputFillTypes[container] = {};
		table.insert(inputFillTypes[container], info);
		container = container+1;
		info = {};
		info.fillLevel = Utils.getNoNil(objectTable:getFillLevel(FillUtil.FILLTYPE_SILAGE), 0)+Utils.getNoNil(objectTable:getFillLevel(FillUtil.FILLTYPE_DRYGRASS_WINDROW), 0);
		info.capacity = 0;
		--if moGuiMiniPdaSlots.animalsCapacity then
		--	info.capacity = Utils.getNoNil(objectTable.totalNumAnimals *  g_forageUsagePerAnimalPerDay.sheep * 6,0);
		--end;
		info.pricePerLiter = 0;
		info.fillTypeContainerName = tostring(moLanguageXml:getTxt("a_foodtrough", nil, "Foodtrough"));
		info.fillTypeName = moSetGetInputOutputLs:getFillTypeName(FillUtil.FILLTYPE_SILAGE).. ",".. moSetGetInputOutputLs:getFillTypeName(FillUtil.FILLTYPE_DRYGRASS_WINDROW);			
		info.lengthFillTypes = 2;
		inputFillTypes[container] = {};
		table.insert(inputFillTypes[container], info);
		container = container+1;
		info = {};
		info.fillLevel = Utils.getNoNil(objectTable:getFillLevel(FillUtil.FILLTYPE_POWERFOOD), 0);
		info.capacity = 0;
		--if moGuiMiniPdaSlots.animalsCapacity then
		--	info.capacity = Utils.getNoNil(objectTable.totalNumAnimals *  g_forageUsagePerAnimalPerDay.sheep * 6,0);
		--end;
		info.pricePerLiter = 0;		
		info.fillTypeName = moSetGetInputOutputLs:getFillTypeName(FillUtil.FILLTYPE_POWERFOOD);			
		info.lengthFillTypes = 1;
		inputFillTypes[container] = {};
		table.insert(inputFillTypes[container], info);
		container = container+1;
		--if objectTable.fillTypes ~= nil then
			--together
		--	for k, v in pairs(objectTable.fillTypes) do
		--		info = {};
		--		info.fillLevel = Utils.getNoNil(objectTable:getFillLevel(v), 0);
		--		info.capacity = -1;
		--		info.pricePerLiter = 0;
		--		info.fillTypeName = moSetGetInputOutputLs:getFillTypeName(v); --tostring(moLanguageXml:getTxt("a_forage", nil, "Forage"));		
		--		info.lengthFillTypes = 1;
		--		inputFillTypes[container] = {};
		--		table.insert(inputFillTypes[container], info);
		--		container = container+1;
		--	end;
		--end;
		table.remove(info);
	end;
	if objectTable.name == "pig" and objectTable.totalNumAnimals >= 1 then
		setAllValues();		
		local info = {};		
		if objectTable.manureFillLevel ~= nil then
			info = {};
			info.fillLevel = Utils.getNoNil(objectTable.manureFillLevel, 0);
			info.capacity = 0;
			info.pricePerLiter = getFruitPrice(self, FillUtil.FILLTYPE_MANURE);
			info.fillTypeName = tostring(moLanguageXml:getTxt("a_manure", nil, "Manure"));		
			info.lengthFillTypes = 1;
			outputFillTypes[container] = {};
			table.insert(outputFillTypes[container], info);
			container = container+1;
		end;
		if objectTable.liquidManureTrigger ~= nil and objectTable.liquidManureTrigger.fillLevel ~= nil then
			info = {};
			info.fillLevel = Utils.getNoNil(objectTable.liquidManureTrigger.fillLevel, 0);
			info.capacity = 0;
			--if moGuiMiniPdaSlots.animalsCapacity then
			--	info.capacity = Utils.getNoNil(objectTable.liquidManureTrigger.capacity, 0);
			--end;
			info.pricePerLiter = getFruitPrice(self, FillUtil.FILLTYPE_LIQUIDMANURE);
			info.fillTypeName = tostring(moLanguageXml:getTxt("a_liquidmanure", nil, "LiquidManure"));		
			info.lengthFillTypes = 1;
			outputFillTypes[container] = {};
			table.insert(outputFillTypes[container], info);
		end;
		container = 1;
		info = {};
		info.fillLevel = Utils.getNoNil(objectTable:getFillLevel(FillUtil.FILLTYPE_WATER), 0)
		info.capacity = 0;
		--if moGuiMiniPdaSlots.animalsCapacity then
		--	info.capacity = Utils.getNoNil(objectTable.totalNumAnimals * objectTable.animalDesc.waterPerDay * 6,0);
		--end;
		info.pricePerLiter = 0;
		info.fillTypeName = tostring(moLanguageXml:getTxt("a_watertrough", nil, "WaterTrog"));		
		info.lengthFillTypes = 1;
		inputFillTypes[container] = {};
		table.insert(inputFillTypes[container], info);
		container = container+1;		
		
		info = {};
		info.fillLevel = Utils.getNoNil(objectTable:getFillLevel(FillUtil.FILLTYPE_STRAW), 0);
		info.capacity = 0;
		--if moGuiMiniPdaSlots.animalsCapacity then
		--	info.capacity = Utils.getNoNil(objectTable.totalNumAnimals * objectTable.animalDesc.strawPerDay * 6,0);
		--end;
		info.pricePerLiter = 0;		
		info.fillTypeName = tostring(moLanguageXml:getTxt("a_straw", nil, "Straw"));	
		info.lengthFillTypes = 1;
		inputFillTypes[container] = {};
		table.insert(inputFillTypes[container], info);
		container = container+1;
		
		info = {};
		info.fillLevel = Utils.getNoNil(objectTable:getFillLevel(FillUtil.FILLTYPE_MAIZE), 0)
		info.capacity = 0;
		--if moGuiMiniPdaSlots.animalsCapacity then
		--	info.capacity = Utils.getNoNil(objectTable.totalNumAnimals * objectTable.animalDesc.foodPerDay * 6,0);
		--end;
		info.pricePerLiter = 0;
		info.fillTypeName = moSetGetInputOutputLs:getFillTypeName(FillUtil.FILLTYPE_MAIZE);		
		info.lengthFillTypes = 1;
		inputFillTypes[container] = {};
		table.insert(inputFillTypes[container], info);
		container = container+1;
		info = {};
		info.fillLevel = Utils.getNoNil(objectTable:getFillLevel(FillUtil.FILLTYPE_WHEAT), 0)+Utils.getNoNil(objectTable:getFillLevel(FillUtil.FILLTYPE_BARLEY), 0); --37,7
		info.capacity = 0;
		--if moGuiMiniPdaSlots.animalsCapacity then
		--	info.capacity = Utils.getNoNil(objectTable.totalNumAnimals * objectTable.animalDesc.foodPerDay * 6,0);
		--end;
		info.pricePerLiter = 0;
		info.fillTypeContainerName = tostring(moLanguageXml:getTxt("a_graintrough", nil, "Graintrough"));
		info.fillTypeName = moSetGetInputOutputLs:getFillTypeName(FillUtil.FILLTYPE_WHEAT).. ",".. moSetGetInputOutputLs:getFillTypeName(FillUtil.FILLTYPE_BARLEY);			
		info.lengthFillTypes = 2;
		inputFillTypes[container] = {};
		table.insert(inputFillTypes[container], info);
		container = container+1;
		info = {};
		info.fillLevel = Utils.getNoNil(objectTable:getFillLevel(FillUtil.FILLTYPE_RAPE), 0)+Utils.getNoNil(objectTable:getFillLevel(FillUtil.FILLTYPE_SUNFLOWER), 0)+Utils.getNoNil(objectTable:getFillLevel(FillUtil.FILLTYPE_SOYBEAN), 0);
		info.capacity = 0;
		--if moGuiMiniPdaSlots.animalsCapacity then
		--	info.capacity = Utils.getNoNil(objectTable.totalNumAnimals * objectTable.animalDesc.foodPerDay * 6,0);
		--end;
		info.pricePerLiter = 0;
		info.fillTypeContainerName = tostring(moLanguageXml:getTxt("a_proteintrough", nil, "Proteintrough"));
		info.fillTypeName = moSetGetInputOutputLs:getFillTypeName(FillUtil.FILLTYPE_RAPE).. ",".. moSetGetInputOutputLs:getFillTypeName(FillUtil.FILLTYPE_SUNFLOWER).. ",".. moSetGetInputOutputLs:getFillTypeName(FillUtil.FILLTYPE_SOYBEAN);			
		info.lengthFillTypes = 3;
		inputFillTypes[container] = {};
		table.insert(inputFillTypes[container], info);
		container = container+1;
		info = {};
		info.fillLevel = Utils.getNoNil(objectTable:getFillLevel(FillUtil.FILLTYPE_POTATO), 0)+Utils.getNoNil(objectTable:getFillLevel(FillUtil.FILLTYPE_SUGARBEET), 0);
		info.capacity = 0;
		--if moGuiMiniPdaSlots.animalsCapacity then
		--	info.capacity = Utils.getNoNil(objectTable.totalNumAnimals * objectTable.animalDesc.foodPerDay * 6,0);
		--end;
		info.pricePerLiter = 0;
		info.fillTypeContainerName = tostring(moLanguageXml:getTxt("a_foodtrough", nil, "Foodtrough"));
		info.fillTypeName = moSetGetInputOutputLs:getFillTypeName(FillUtil.FILLTYPE_POTATO).. ",".. moSetGetInputOutputLs:getFillTypeName(FillUtil.FILLTYPE_SUGARBEET);			
		info.lengthFillTypes = 2;
		inputFillTypes[container] = {};
		table.insert(inputFillTypes[container], info);
		container = container+1;
		table.remove(info);
	end;
	return inputFillTypes, outputFillTypes;
end;

function moSetGetInputOutputLs:getPlaceableShop(self, objectTable)	
	local inputFillTypes={};
	local outputFillTypes={};	
	local container = 1;
	local ratio = 0;
	local productivity = 0;
	local productivityColor = moGuiMiniPdaSlots.warningColor0;
	local fillLevel = 0;
	local capacity = 0;
	local inputEmpty = false;	
	if objectTable ~= nil and objectTable.tipTrigger ~= nil then	
		function setIncomePerHour()
			local info = {};			
			info.fillTypeName = tostring(moLanguageXml:getTxt("greenhousels"));		
			info.lengthFillTypes = 1;		
			info.pricePerLiter = 0;
			if not inputEmpty then info.pricePerLiter = Utils.getNoNil(objectTable.incomePerHour, 0);end;		
			info.fillLevel = 0;
			info.capacity = -2;		
			inputFillTypes[container] = {};
			table.insert(inputFillTypes[container], info);
			container = container+1;
			table.remove(info);
		end;
		setIncomePerHour();		
		if objectTable.tipTrigger.acceptedFillTypes ~= nil then			
			for fillType,isAccepted in pairs(objectTable.tipTrigger.acceptedFillTypes) do				
				if (isAccepted) then
					local info = {};
					info.fillLevel = 0; --Utils.getNoNil(v.acceptedFillTypes:getFillLevel(fillType), 0);				
					info.capacity = -2;
					info.pricePerLiter = 0;
					info.fillTypeName = moSetGetInputOutputLs:getFillTypeName(fillType); --tostring(moLanguageXml:getTxt("a_forage", nil, "Forage"));	moSetGetInputOutputLs:getFillTypeStringName(self, fillType, fillTypeNameString, fillTypeName)	
					info.lengthFillTypes = 1;
					--local bestPrice = Utils.getNoNil(objectTable.tipTrigger.getEffectiveFillTypePrice(fillType), 0)*1000;					
					local bestPrice = Utils.getNoNil(moSetGetStationes:getFillTypePrice(objectTable.tipTrigger, nil, fillType, 0))*1000
					local bestPriceFillType = getFruitPrice(self, fillType);					
					info.setColor = moGuiMiniPdaSlots.priceColor;					
					if tonumber(bestPrice) > tonumber(bestPriceFillType) then info.setColor = moGuiMiniPdaSlots.bestPriceColor;end;
					bestPrice = string.format("%.1f", bestPrice);
					info.extraText = tostring(bestPrice).. " ".. tostring(moLanguageXml:getTxt("moneysymbol"));
					inputFillTypes[container] = {};
					table.insert(inputFillTypes[container], info);
					container = container+1;
					table.remove(info);
				end;
			end;
		end;		
	end;
	return inputFillTypes, outputFillTypes;
end;

function moSetGetInputOutputLs:getHeap(self, objectTable)	
	local inputFillTypes={};
	local outputFillTypes={};	
	local container = 1;
	local ratio = 0;
	local productivity = 0;
	local productivityColor = moGuiMiniPdaSlots.warningColor0;
	local fillLevel = 0;
	local capacity = 0;
	local inputEmpty = false;	
	if objectTable ~= nil then		
		function setHeap()
			local info = {};			
			info.fillTypeName = moSetGetInputOutputLs:getFillTypeName(objectTable.fillType);		
			info.lengthFillTypes = 1;		
			info.pricePerLiter = Utils.getNoNil(getFruitPrice(self, objectTable.fillType), 0);					
			info.fillLevel = fillLevel;
			info.capacity = -1;		
			outputFillTypes[container] = {};
			table.insert(outputFillTypes[container], info);
			table.remove(info);
		end;				
		fillLevel = TipUtil.getFillLevelAtArea(objectTable.fillType, objectTable.hx, objectTable.hz, objectTable.widthX, objectTable.widthZ, objectTable.heightX, objectTable.heightZ);
		if fillLevel ~= nil and fillLevel ~= 0 then
			setHeap();
		else
			--table.remove(objectTable);
		end;
	end;
	return inputFillTypes, outputFillTypes;
end;

function moSetGetInputOutputLs:getPlaceableStorage(self, objectTable)	
	local inputFillTypes={};
	local outputFillTypes={};	
	local container = 1;
	local ratio = 0;
	local productivity = 0;
	local productivityColor = moGuiMiniPdaSlots.warningColor0;
	local fillLevel = 0;
	local capacity = 0;
	local inputEmpty = false;	
	if objectTable ~= nil and objectTable.configFileName ~= nil and objectTable.storage ~= nil then		
		function setCostPerDay()
			local info = {};			
			info.fillTypeName = tostring(moLanguageXml:getTxt("costperday", nil, "Cost(Day)"));		
			info.lengthFillTypes = 1;		
			info.pricePerLiter = 0;
			if not inputEmpty then info.pricePerLiter = tonumber(Utils.getNoNil(objectTable.storage.costsPerFillLevelAndDay, 0));end;		
			--print("price per liter....".. tostring(info.pricePerLiter))
			info.fillLevel = 0;
			info.capacity = -2;
			if info.pricePerLiter == 0 then 
				info.extraText = tostring(moLanguageXml:getTxt("costperdayno", nil, "No"));
				info.setColor = moGuiMiniPdaSlots.warningColor0;
			else
				info.extraText = tostring(moLanguageXml:getTxt("costperdayon", nil, "Yes"));
				info.setColor = moGuiMiniPdaSlots.warningColor2
			end;
			outputFillTypes[container] = {};
			table.insert(outputFillTypes[container], info);
			container = container+1;
		end;		
		if objectTable.storage.fillTypes ~= nil then
			--together
			for k, v in pairs(objectTable.storage.fillTypes) do
				info = {};
				info.fillLevel = Utils.getNoNil(objectTable.storage:getFillLevel(v), 0);
				fillLevel = fillLevel+info.fillLevel;
				info.capacity = 0;
				info.pricePerLiter = getFruitPrice(self, v);
				info.fillTypeName = moSetGetInputOutputLs:getFillTypeName(v); --tostring(moLanguageXml:getTxt("a_forage", nil, "Forage"));	
				info.lengthFillTypes = 1;
				inputFillTypes[container] = {};
				table.insert(inputFillTypes[container], info);
				container = container+1;
			end;
		end;
		container = 1;
		local info = {};
		info.fillTypeName = tostring(moLanguageXml:getTxt("capacity", nil, "Capacity"));		
		info.lengthFillTypes = 1;
		info.pricePerLiter = 0;		
		info.fillLevel = fillLevel;
		info.capacity = Utils.getNoNil(objectTable.storage.capacity, 0);
		capacity = info.capacity;
		info.productivity = string.format("%1.0f", "".. tonumber(fillLevel)/tonumber(capacity)*100);
		info.productivityColor = getProzentColor(info.productivity); --moGuiExtras.colors['green'];
		outputFillTypes[container] = {};
		table.insert(outputFillTypes[container], info);
		container = container+1;
		setCostPerDay();
		--local info = {};
		--info.fillTypeName = tostring(moLanguageXml:getTxt(xmlModString)).. " ".. tostring(moLanguageXml:getTxt("amount", nil, "Amount"));		
		--info.lengthFillTypes = 1;
		--info.pricePerLiter = 0;		
		--info.fillLevel = 0;
		--info.capacity = -1;
		--info.productivity = string.format("%1.0f", Utils.getNoNil(objectTable.productivity*100, 0)); --Utils.getNoNil(objectTable.productivity*100, 0); --string.format("%0.0f", Utils.getNoNil(0, 0));
		--info.productivityColor = getProductivityColor(self, info.productivity); --moGuiExtras.colors['green'];
		--outputFillTypes[container] = {};
		--table.insert(outputFillTypes[container], info);
		
		
		--key2 und value2 ...isManuallyReplicated-----true
		--key2 und value2 ...storageDirtyFlag-----1
		--key2 und value2 ...id-----116
		--key2 und value2 ...isServer-----true
		--key2 und value2 ...isRegistered-----true
		--key2 und value2 ...rootNode-----100014
		--key2 und value2 ...storageName-----Storage
		--key2 und value2 ...fillTypes-----table: 0x470b55a6d8
		--key2 und value2 ...saveId-----Storage_farmSiloExtensionLarge
		--key2 und value2 ...ownsRootNode-----false
		--key2 und value2 ...capacity-----100000
		--key2 und value2 ...dirtyMask-----0
		--key2 und value2 ...loadedValues-----table: 0x470b55a488
		--key2 und value2 ...costsPerFillLevelAndDay-----0
		--key2 und value2 ...sortedFillTypes-----table: 0x470b6fc7c8
		--key2 und value2 ...tipTriggers-----table: 0x470b6fc738
		--key2 und value2 ...isClient-----true
		--key2 und value2 ...fillLevels-----table: 0x470b6fc810
		--key2 und value2 ...siloTriggers-----table: 0x470b6fc780
		--key2 und value2 ...nextDirtyFlag-----2
	end;
	return inputFillTypes, outputFillTypes;
end;

function moSetGetInputOutputLs:getFillTypeName(fillType)
	local desc = FillUtil.fillTypeIndexToDesc[fillType];
	if desc ~= nil and moFillTypes[desc.index] ~= nil and moFillTypes[desc.index].fruitName ~= nil then
		return moFillTypes[desc.index].fruitName;
	elseif desc ~= nil then
		return desc.name;
	end;
	return "Unknow";
end;

function moSetGetInputOutputLs:getFillTypeStringName(self, fillType, fillTypeNameString, fillTypeName)
	local pricePerLiter = 0;
	local stringName = fillTypeNameString;
	local desc = FillUtil.fillTypeIndexToDesc[fillType];	
	if desc ~= nil and moFillTypes[desc.index] ~= nil and moFillTypes[desc.index].fruitName ~= nil then								
		local bestPriceTemp = 1;
		if moFillTypes[desc.index].bestPrice ~= 0 then bestPriceTemp = moFillTypes[desc.index].bestPrice;end;
		pricePerLiter = moFillTypes[desc.index].pricePerLiter*bestPriceTemp*moGeneralSettings.difficultyMultiplier*moFillTypes[desc.index].greatDemandMultiplier*1000;		
		if not string.find(stringName, moFillTypes[desc.index].fruitName) then
			if string.len(stringName) > 0 then
				stringName = stringName.. ",".. moFillTypes[desc.index].fruitName;									
			else
				stringName = moFillTypes[desc.index].fruitName;
			end;								
		end;
	elseif fillTypeName ~= nil then		
		if not string.find(stringName, fillTypeName) then
			if string.len(stringName) > 0 then
				stringName = stringName.. ",".. fillTypeName;									
			else
				stringName = fillTypeName;
			end;								
		end;
	else
		if not string.find(stringName, tostring(moLanguageXml:getTxt("unknow"))) then
			if string.len(stringName) > 0 then
				stringName = stringName.. ",".. tostring(moLanguageXml:getTxt("unknow"));									
			else
				stringName = tostring(moLanguageXml:getTxt("unknow"));
			end;								
		end;	
	end;	
	return pricePerLiter, stringName
end;

function getProzentColor(fillProzent)	
	local ratio = tonumber(fillProzent);
	local color = moGuiMiniPdaSlots.warningColor0;
	if tonumber(ratio) >= 90 then		
		return moGuiMiniPdaSlots.warningColor4;
	elseif tonumber(ratio) < 90 and tonumber(ratio) >= 75 then		
		return moGuiMiniPdaSlots.warningColor3;
	elseif tonumber(ratio) < 75 and tonumber(ratio) >= 50 then
		return moGuiMiniPdaSlots.warningColor2;
	elseif tonumber(ratio) < 50 and tonumber(ratio) >= 15 then		
		return moGuiMiniPdaSlots.warningColor1;
	elseif tonumber(ratio) < 15 then		
		return moGuiMiniPdaSlots.warningColor0;
	end;
	return color;
end;

function getProductivityColor(self, productivity)
	local ratio = productivity;
	local color = moGuiMiniPdaSlots.warningColor0;
	if tonumber(ratio) <= 90 and tonumber(ratio) >= 75 then
		color = moGuiMiniPdaSlots.warningColor1; --moGuiExtras.colors['greenDisabled'];
	elseif tonumber(ratio) < 75 and tonumber(ratio) >= 50 then
		color = moGuiMiniPdaSlots.warningColor2; --moGuiExtras.colors['yellow'];
	elseif tonumber(ratio) < 50 and tonumber(ratio) >= 25 then
		color = moGuiMiniPdaSlots.warningColor3; --moGuiExtras.colors['red'];
	elseif tonumber(ratio) < 25 then
		color = moGuiMiniPdaSlots.warningColor4; --moGuiExtras.colors['redDisabled'];
	end;
	return color;
end;

function getEggPrice(self, fillType)
	local bestPrice = 0;	
	local desc = FillUtil.fillTypeIndexToDesc[fillType];	
	if desc ~= nil and moFillTypes[desc.index] ~= nil then		
		bestPrice = 1*moFillTypes[desc.index].pricePerLiter*moGeneralSettings.difficultyMultiplier;		
	end;
	return bestPrice;
end;

function getFruitPrice(self, fillType)	
	local bestPrice = 0;	
	local desc = FillUtil.fillTypeIndexToDesc[fillType];	
	if desc ~= nil and moFillTypes[desc.index] ~= nil then		
		if moFillTypes[desc.index].bestPrice ~= 0 then 
			bestPrice = string.format("%.1f", moFillTypes[desc.index].bestPrice);
		else
			bestPrice = string.format("%.1f", Utils.getNoNil(g_currentMission.economyManager:getPricePerLiter(desc.index, 0)));
		end;		
	end;
	return bestPrice;
end;

function getAnimalStorePrice(self, name)	
	local bestPrice = 0;	
	local storeItem = StoreItemsUtil.storeItemsByXMLFilename[name];
	if storeItem ~= nil then
		bestPrice = storeItem.price;
	end;
	return bestPrice;
end;

function getAnimalPrice(self, name)	
	local bestPrice = 0;	
	local desc = FillUtil.fillTypeNameToDesc[name];
	if desc ~= nil and moFillTypes[desc.index] ~= nil then 
		local bestPriceTemp = 1;
		if moFillTypes[desc.index].bestPrice ~= 0 then bestPriceTemp = moFillTypes[desc.index].bestPrice;end;
		bestPrice = moFillTypes[desc.index].pricePerLiter/1000*bestPriceTemp*moGeneralSettings.difficultyMultiplier*moFillTypes[desc.index].greatDemandMultiplier*1000;
	end;
	return bestPrice;
end;

function getWaterModFruitName(self, fillType)	
	local fruitName = tostring(moLanguageXml:getTxt("unknow"));	
	local desc = FillUtil.fillTypeIndexToDesc[fillType];
	if desc ~= nil and moFillTypes[desc.index] ~= nil then 
		fruitName = string.lower(desc.name);		
	end;
	return fruitName;
end;